﻿
// Starting function
// Loads the "ptm_jquery1.4.1.min" library which is necessary for the request.

function StartAMPlugin() {

    if (typeof jQuery == 'undefined') {

        var fileref = document.createElement('script')
        fileref.setAttribute("type", "text/javascript")
        fileref.setAttribute("src", "/WebResources/ptm_jquery1.4.1.min")


        fileref.onreadystatechange = function () {

            if (this.readyState == 'loaded') {
                isAppointment = true;
                ptm_LoadJGeneralFunctions();
            }
        }

        document.getElementsByTagName("head")[0].appendChild(fileref);
    }
    else {
        ptm_LoadJGeneralFunctions();
    }
}



// Loads the "ptm_GeneralJSFunctions.js" library which is used to execute the retrieve multiple -request.

function ptm_LoadJGeneralFunctions() {

    if (typeof $ptm == 'undefined') {

        var fileref = document.createElement('script')
        fileref.setAttribute("type", "text/javascript")
        fileref.setAttribute("src", "/WebResources/ptm_GeneralJSFunctions.js")


        fileref.onreadystatechange = function () {

            if (this.readyState == 'loaded') {
                isAppointment = true;
                ptm_LoadFilesFinished();
            }
        }

        document.getElementsByTagName("head")[0].appendChild(fileref);
    }
    else {
        ptm_LoadFilesFinished();
    }
}




// This function gets triggered when the “ptm_GeneralJSFunctions.js” library is loaded.
// Then it triggers the plugin.

function ptm_LoadFilesFinished() {

    var filter = "<AMPluginParameters>";
    filter += "<EnableSingleDebugging>false</EnableSingleDebugging>";
    filter += "<MessageType>Create</MessageType>";
    filter += "<PrimaryEntityId>9273234A-49BF-DE11-A2B1-001C259A7924</PrimaryEntityId>";
    filter += "<PrimaryEntityLogicalName>account</PrimaryEntityLogicalName>";
    filter += "<TemplateId>B66A28C1-3D4F-E111-A35C-00155DC88112</TemplateId>";
    filter += "<SaveAs>docx</SaveAs>";
    filter += "<SaveLocation>1</SaveLocation>";
    filter += "<PrintTo></PrintTo>";
    filter += "</AMPluginParameters>";

    $ptm.retrieveMultiple("ptm_mscrmaddonscomamtriggerSet", "?$filter=(ptm_name eq 'cmd_automerge') or (ptm_FullXML eq '" + filter + "')&$select=ptm_FullXML", CreateDocumentFinished, CreateDocumentError);

}



//This function handles the plugin result.

function CreateDocumentFinished(data, textStatus, XmlHttpRequest) {
    if (data != null && data.length >= 1 && data[0].ptm_FullXML != undefined) {
        var response = data[0].ptm_FullXML;
        var indexOfPipe = response.indexOf("|");
        var documentId = "";

        if (indexOfPipe >= 0 && (response.indexOf("valid") != -1 || response.indexOf("trial") != -1) && response.toLowerCase().indexOf("error") == -1) {
            documentId = response.substr(indexOfPipe + 1);

            indexOfPipe = documentId.indexOf("|");

            if (indexOfPipe != -1) {
                documentId = documentId.substr(0, indexOfPipe);
            }
        }
        else {
            alert("ERROR: While creating document");
        }
    }
    else {
        alert("ERROR: While creating document");
    }
}



// This function gets triggered the retrieve multiple request itself was unsuccessful.

function CreateDocumentError(XmlHttpRequest, textStatus, errorThrown) {

    alert("Error: The RetrieveMultiple-request threw an error!");
}